<template>
  <v-app id="register" style="background-color:#1B396A">
    <header-tecnm></header-tecnm>
    <v-container style="background-color:#1B396A; max-height:700px" class="overflow-y-auto">
      <h2
        style="color: white;text-align:center;"
        :class="[display ? 'none' : '']"
      >Se ha cerrado el registro</h2>
      <v-form :class="[display ? '' : 'none']">
        <v-row
          style="background-color:white; margin:2%; border-radius: 20px; padding:2%"
          justify="center"
        >
          <v-col cols="12" md="5">
            <v-text-field
              v-model="control_number"
              label="Número de control"
              :rules="control_number_rules"
              validate-on-blur
            ></v-text-field>
            <v-text-field v-model="name" label="Nombre" :rules="name_rules" validate-on-blur></v-text-field>
            <v-text-field
              v-model="lastname"
              label="Apellidos"
              :rules="lastname_rules"
              validate-on-blur
            ></v-text-field>
            <v-text-field v-model="email" label="Email" :rules="email_rules" validate-on-blur></v-text-field>
            <div class="hello">
              <picture-input
                v-model="payment"
                ref="pictureInput"
                @change="onChange"
                style="width:50%; height:50%;"
                margin="16"
                accept="image/jpeg, image/png"
                size="10"
                buttonClass="btn"
                :customStrings="{
                  upload: '<h1>Bummer!</h1>',
                  drag: 'Arrastra una imágen aquí'
                }"
              ></picture-input>
            </div>
          </v-col>
          <v-col cols="12" md="5">
            <v-select
              v-model="select_career"
              :items="carreer"
              item-text="name"
              item-value="id"
              menu-props="auto"
              label="Carrera"
              hide-details
              prepend-icon
              single-line
            ></v-select>
            <v-text-field v-model="semester" label="Semestre"></v-text-field>
            <v-select
              v-model="select_speciality"
              :items="items[this.index]['specialties']"
              menu-props="auto"
              label="Especialidad"
              hide-details
              prepend-icon
              single-line
            ></v-select>
            <v-text-field
              v-model="start_year"
              label="Año de entrada"
              :rules="start_year_rules"
              validate-on-blur
            ></v-text-field>
            <v-text-field
              v-model="end_year"
              label="Año de salida"
              :rules="end_year_rules"
              validate-on-blur
            ></v-text-field>
            <v-btn
              color="#1B396A"
              style="color: white; margin-left: 50%; transform: translateX(-50%);"
              @click="registerx()"
            >Registra tu solicitud</v-btn>
          </v-col>
        </v-row>
      </v-form>
    </v-container>
  </v-app>
</template>

<script>
import headerTecnm from "@/components/common/headerTecnm";
import PictureInput from "vue-picture-input";
import firebase from "firebase";

//var storage = firebase.storage();

export default {
  components: {
    headerTecnm,
    PictureInput
  },
  data() {
    return {
      display: true,
      items: [],
      carreer: [],
      select_career: "",
      select_speciality: "",
      index: 0,
      control_number: "",
      email: "",
      end_year: "",
      lastname: "",
      name: "",
      payment: null,
      semester: "",
      specialty: "",
      start_year: "",
      control_number_rules: [
        value => !!value || "N° de control requerido",
        value =>
          (value && value.length < 10 && value.length > 7) ||
          "N° de control incorrecto",
        value => {
          const pattern = /^[0-9]*$/;
          return pattern.test(value) || "N° de control inválido";
        }
      ],
      name_rules: [
        value => !!value || "Nombre requerido",
        value => (value && value.length < 30) || "Nombre incorrecto",
        value => {
          const pattern = /^[A-Za-zÁÉÍÓÚñáéíóúÑ]*$/;
          return pattern.test(value) || "Nombre inválido";
        }
      ],
      lastname_rules: [
        value => !!value || "Apellido requerido",
        value => (value && value.length < 30) || "Apellido incorrecto",
        value => {
          const pattern = /^[A-Za-zÁÉÍÓÚñáéíóúÑ\s]*$/;
          return pattern.test(value) || "Apellido inválido";
        }
      ],
      email_rules: [
        value => !!value || "email requerido",
        value => (value && value.length < 50) || "email incorrecto",
        value => {
          const pattern = /^[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+@[a-zA-Z0-9-]+(?:\.[a-zA-Z0-9-]+)*$/;
          return pattern.test(value) || "email inválido";
        }
      ],
      start_year_rules: [
        value => !!value || "año de inicio requerido",
        value =>
          (value && value.length < 5 && value.length > 3) || "año incorrecto",
        value => {
          const pattern = /^(19|20)\d{2}$/;
          return pattern.test(value) || "año inválido";
        }
      ],
      end_year_rules: [
        value => !!value || "año de fin requerido",
        value =>
          (value && value.length < 5 && value.length > 3) || "año incorrecto",
        value => {
          const pattern = /^(19|20)\d{2}$/;
          return pattern.test(value) || "año inválido";
        }
      ]
    };
  },
  methods: {
    async registerx() {
      var db = firebase.firestore();
      var storageRef = firebase.storage().ref();
      var ref = storageRef.child(
        "paid_tickets/" + this.control_number + ".jpg"
      );
      var idRefClient = db.collection("requests");
      try {
        var stat = false;
        const snapshot = await idRefClient.get();

        snapshot.forEach(doc => {
          if (doc.data().control_number == this.control_number) {
            stat = true;
          }
        });
        if (stat) {
          console.log("NO registrar");
        } else {
          db.collection("requests")
            .add({
              accepted: 0,
              career: db.doc(`/careers/${this.select_career}`),
              control_number: this.control_number,
              email: this.email,
              end_year: this.end_year,
              lastname: this.lastname,
              name: this.name,
              payment: ref.fullPath,
              semester: this.semester,
              specialty: this.select_speciality,
              start_year: this.start_year
            })
            .then(function(docRef) {
              console.log("Document written with ID: ", docRef.id);
            })
            .catch(function(error) {
              console.error("Error adding document: ", error);
            });
          ref.put(this.$refs.pictureInput.file).then(function(snapshot) {
            console.log("Uploaded a blob or file!");
          });
        }
      } catch (error) {
        console.log("Error getting documents", error);
      }
      /*
       */
      this.$swal("Listo", "Se ha enviado la solicitud", "success").then(
        function() {
          window.location.reload();
        }
      );
    },
    onChange() {}
  },
  async created() {
    var db = firebase.firestore();
    var idRefClient = db.collection("careers");
    try {
      var stat = false;
      const snapshot = await idRefClient.get();

      snapshot.forEach(doc => {
        var tempo = { name: "", specialties: [], id: "" };
        tempo.name = doc.data()["name"];
        tempo.id = doc.id;
        tempo.specialties = doc.data()["specialties"];
        this.items.push(tempo);
        this.carreer.push(tempo);
        this.$store.commit("pushCarreer", this.items);
      });

      const config = await db
        .collection("config")
        .doc(`0vFBCMlgVFa8QYiVuFuU`)
        .get();

      this.display = config.data().open;

      console.log(this.items);
    } catch (error) {
      console.log("Error getting documents", error);
    }
  },
  updated() {
    for (var i in this.carreer) {
      if (this.carreer[i]["id"] == this.select_career) {
        this.index = i;
        break;
      }
    }
  }
};
</script>

<style scoped>
.none {
  display: none !important;
}
</style>